# \QueryQuery_Builder_Interface

Interface defining the Query Builder class

## Summary

Methods
Constants
select()
select_max()
select_min()
select_avg()
select_sum()
distinct()
explain()
from()
like()
or_like()
not_like()
or_not_like()
having()
or_having()
where()
or_where()
where_in()
or_where_in()
where_not_in()
or_where_not_in()
set()
join()
group_by()
order_by()
limit()
group_start()
or_group_start()
or_not_group_start()
group_end()
get()
get_where()
count_all()
count_all_results()
insert()
insert_batch()
update()
delete()
get_compiled_select()
get_compiled_insert()
get_compiled_update()
get_compiled_delete()
reset_query()
No constants found
No protected methods found
N/A
No private methods found
N/A

File
  src/Query/Query_Builder_Interface.php
Package
  \Query\Query_Builder

## Tags

None found

## Methods

### select()

    select(string  $fields) : \Query\Query_Builder

Specifies rows to select in a query

#### Parameters

string | $fields |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### select_max()

    select_max(string  $field, string|boolean  $as = FALSE) : \Query\Query_Builder

Selects the maximum value of a field from a query

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### select_min()

    select_min(string  $field, string|boolean  $as = FALSE) : \Query\Query_Builder

Selects the minimum value of a field from a query

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### select_avg()

    select_avg(string  $field, string|boolean  $as = FALSE) : \Query\Query_Builder

Selects the average value of a field from a query

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### select_sum()

    select_sum(string  $field, string|boolean  $as = FALSE) : \Query\Query_Builder

Selects the sum of a field from a query

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### distinct()

    distinct() : \Query\Query_Builder

Adds the 'distinct' keyword to a query

#### Returns

\Query\Query_Builder

#

## Tags

None found

### explain()

    explain() : \Query\Query_Builder

Shows the query plan for the query

#### Returns

\Query\Query_Builder

#

## Tags

None found

### from()

    from(string  $tblname) : \Query\Query_Builder

Specify the database table to select from

#### Parameters

string | $tblname |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### like()

    like(string  $field, mixed  $val, string  $pos = 'both') : \Query\Query_Builder

Creates a Like clause in the sql statement

#### Parameters

string | $field |
mixed | $val |
string | $pos |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### or_like()

    or_like(string  $field, mixed  $val, string  $pos = 'both') : \Query\Query_Builder

Generates an OR Like clause

#### Parameters

string | $field |
mixed | $val |
string | $pos |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### not_like()

    not_like(string  $field, mixed  $val, string  $pos = 'both') : \Query\Query_Builder

Generates a NOT LIKE clause

#### Parameters

string | $field |
mixed | $val |
string | $pos |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### or_not_like()

    or_not_like(string  $field, mixed  $val, string  $pos = 'both') : \Query\Query_Builder

Generates a OR NOT LIKE clause

#### Parameters

string | $field |
mixed | $val |
string | $pos |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### having()

    having(mixed  $key, mixed  $val = array()) : \Query\Query_Builder

Generates a 'Having' clause

#### Parameters

mixed | $key |
mixed | $val |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### or_having()

    or_having(mixed  $key, mixed  $val = array()) : \Query\Query_Builder

Generates a 'Having' clause prefixed with 'OR'

#### Parameters

mixed | $key |
mixed | $val |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### where()

    where(mixed  $key, mixed  $val = array(), boolean  $escape = NULL) : \Query\Query_Builder

Specify condition(s) in the where clause of a query Note: this function works with key / value, or a passed array with key / value pairs

#### Parameters

mixed | $key |
mixed | $val |
boolean | $escape |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### or_where()

    or_where(string  $key, mixed  $val = array()) : \Query\Query_Builder

Where clause prefixed with "OR"

#### Parameters

string | $key |
mixed | $val |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### where_in()

    where_in(mixed  $field, mixed  $val = array()) : \Query\Query_Builder

Where clause with 'IN' statement

#### Parameters

mixed | $field |
mixed | $val |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### or_where_in()

    or_where_in(string  $field, mixed  $val = array()) : \Query\Query_Builder

Where in statement prefixed with "or"

#### Parameters

string | $field |
mixed | $val |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### where_not_in()

    where_not_in(string  $field, mixed  $val = array()) : \Query\Query_Builder

WHERE NOT IN (FOO) clause

#### Parameters

string | $field |
mixed | $val |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### or_where_not_in()

    or_where_not_in(string  $field, mixed  $val = array()) : \Query\Query_Builder

OR WHERE NOT IN (FOO) clause

#### Parameters

string | $field |
mixed | $val |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### set()

    set(mixed  $key, mixed  $val = NULL) : \Query\Query_Builder

Sets values for inserts / updates / deletes

#### Parameters

mixed | $key |
mixed | $val |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### join()

    join(string  $table, string  $condition, string  $type = '') : \Query\Query_Builder

Creates a join phrase in a compiled query

#### Parameters

string | $table |
string | $condition |
string | $type |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### group_by()

    group_by(mixed  $field) : \Query\Query_Builder

Group the results by the selected field(s)

#### Parameters

mixed | $field |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### order_by()

    order_by(string  $field, string  $type = "") : \Query\Query_Builder

Order the results by the selected field(s)

#### Parameters

string | $field |
string | $type |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### limit()

    limit(integer  $limit, integer|boolean  $offset = FALSE) : \Query\Query_Builder

Set a limit on the current sql statement

#### Parameters

integer | $limit |
integer|boolean | $offset |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### group_start()

    group_start() : \Query\Query_Builder

Adds a paren to the current query for query grouping

#### Returns

\Query\Query_Builder

#

## Tags

None found

### or_group_start()

    or_group_start() : \Query\Query_Builder

Adds a paren to the current query for query grouping, prefixed with 'OR'

#### Returns

\Query\Query_Builder

#

## Tags

None found

### or_not_group_start()

    or_not_group_start() : \Query\Query_Builder

Adds a paren to the current query for query grouping, prefixed with 'OR NOT'

#### Returns

\Query\Query_Builder

#

## Tags

None found

### group_end()

    group_end() : \Query\Query_Builder

Ends a query group

#### Returns

\Query\Query_Builder

#

## Tags

None found

### get()

    get(  $table = '', integer|boolean  $limit = FALSE, integer|boolean  $offset = FALSE) : \PDOStatement

Select and retrieve all records from the current table, and/or execute current compiled query

#### Parameters

| $table |
integer|boolean | $limit |
integer|boolean | $offset |

#### Returns

\PDOStatement

#

## Tags

None found

### get_where()

    get_where(string  $table, array  $where = array(), integer|boolean  $limit = FALSE, integer|boolean  $offset = FALSE) : \PDOStatement

Convience method for get() with a where clause

#### Parameters

string | $table |
array | $where |
integer|boolean | $limit |
integer|boolean | $offset |

#### Returns

\PDOStatement

#

## Tags

None found

### count_all()

    count_all(string  $table) : integer

Retrieve the number of rows in the selected table

#### Parameters

string | $table |

#### Returns

integer

#

## Tags

None found

### count_all_results()

    count_all_results(string  $table = '') : integer

Retrieve the number of results for the generated query - used in place of the get() method

#### Parameters

string | $table |

#### Returns

integer

#

## Tags

None found

### insert()

    insert(string  $table, mixed  $data = array()) : \PDOStatement

Creates an insert clause, and executes it

#### Parameters

string | $table |
mixed | $data |

#### Returns

\PDOStatement

#

## Tags

None found

### insert_batch()

    insert_batch(string  $table, array  $data = array()) : \PDOStatement|null

Creates and executes a batch insertion query

#### Parameters

string | $table |
array | $data |

#### Returns

\PDOStatement|null

#

## Tags

None found

### update()

    update(string  $table, mixed  $data = array()) : \PDOStatement

Creates an update clause, and executes it

#### Parameters

string | $table |
mixed | $data |

#### Returns

\PDOStatement

#

## Tags

None found

### delete()

    delete(string  $table, mixed  $where = '') : \PDOStatement

Deletes data from a table

#### Parameters

string | $table |
mixed | $where |

#### Returns

\PDOStatement

#

## Tags

None found

### get_compiled_select()

    get_compiled_select(string  $table = '', boolean  $reset = TRUE) : string

Returns the generated 'select' sql query

#### Parameters

string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### get_compiled_insert()

    get_compiled_insert(string  $table, boolean  $reset = TRUE) : string

Returns the generated 'insert' sql query

#### Parameters

string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### get_compiled_update()

    get_compiled_update(string  $table = '', boolean  $reset = TRUE) : string

Returns the generated 'update' sql query

#### Parameters

string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### get_compiled_delete()

    get_compiled_delete(string  $table = "", boolean  $reset = TRUE) : string

Returns the generated 'delete' sql query

#### Parameters

string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### reset_query()

    reset_query() : void

Clear out the class variables, so the next query can be run

#

## Tags

None found

### Query_Builder_Interface.php